import logging
import math

import numpy as np
import pandas as pd
from scipy.stats import pearsonr, zscore
from sklearn.model_selection import StratifiedKFold, KFold, train_test_split

from data.filters import DeviceFractionFilter, \
    LocationFractionFilter, MultipleLocationFractionFilter, IsInFilter, \
    MultipleDeviceFractionFilter, RangeFilter

log = logging.getLogger(__name__)
TIME_FORMAT = '%Y-%m-%d %H:%M:%S'


class DataProviderBase:

    def __init__(self):
        # stores the RSS data as numpy array for fixed number of APs
        self.data_tensor = None

        # continuous positions tags of RSS data (row_id corresponds to RSS)
        self.labels = None
        self.noisy_labels = None

        # one-hot encoded area labels (row_id corresponds to RSS)
        self.area_labels = None
        self.noisy_area_labels = None

        # numpy array that stores the uuids (row_id corresponds to RSS)
        self.uids = None

        # numpy array that stores the timestamps of fingerprints
        # (row_id corresponds to RSS)
        self.timestamps = None

        # list of length (num_splits) that holds
        # a tuple of (train, test) indices in each entry
        self.splits_indices = None
        self.split_ratio = None
        self.num_splits = 0
        self.current_split_idx = 0

        # floor plan information
        self.floorplan_width = 0
        self.floorplan_height = 0

        self.measurements_df: pd.DataFrame = None
        self.filtered_df: pd.DataFrame = None
        self.mac_addresses_df = None
        self.col_df: pd.DataFrame = None

        # random state of any method that uses randomization
        self.random_state = 1

    def set_area_labels(self, area_labels, delete_uncovered=True, pre_params=None, noisy=False):
        """
        Set the class parameter area labels. This allows to detect data, where
        corresponding labels are not covered. If required those can be eliminated
        from the data set. If this happens, we have the recalculate the k-fold
        splitting indices.
        :param area_labels: The new area labels
        :param delete_uncovered: Whether to delete data that is not matched by
        floor plan segmentation
        :param pre_params: The supplied preprocessing parameters of the pipeline
        :return:
        """
        if delete_uncovered:
            mask = np.where(np.any(area_labels != 0, axis=1))[0]
            ratio = 1 - len(mask) / len(self.data_tensor)
            log.info(
                "Deleted {}% of data, since labels did not match floor plan "
                "segmentation".format(np.round(ratio * 100, decimals=0)))

            if self.filtered_df is not None and 'split' in self.filtered_df:
                # do not delete data but only indices in split
                self.area_labels = area_labels
                for (train, test) in self.splits_indices:
                    train = train[np.where(np.isin(train, mask))[0]]
                    test = test[np.where(np.isin(test, mask))[0]]
            else:
                if noisy:
                    log.info("Setting noisy labels, deletion not supported yet")
                    self.noisy_area_labels = area_labels
                else:
                    self.labels = self.labels[mask, :]
                    self.area_labels = area_labels[mask, :]
                    self.data_tensor = self.data_tensor[mask, :]
                    if self.uids is not None:
                        self.uids = self.uids[mask]

            self.generate_split_indices(pre_params)
        else:
            self.area_labels = area_labels

    def generate_split_indices(self, pre_params=None):
        """
        Generates split indices for the current data set. If the a
        'split_user_id' is specified in the pre_params, the this is used to only
        apply the split on the subset of this device, while using the rest of
        the data as training data only.
        :param pre_params: preprocessing params supplied for pipeline
        :return:
        """
        if pre_params is not None and 'split_user_id' in pre_params:
            self.generate_split_indices_for_device(pre_params['split_user_id'])

        elif self.filtered_df is None or 'split' not in self.filtered_df:
            self._generate_split_indices()

    def generate_split_indices_for_device(self, user_ids):
        """
        Only uses the subset of data the is generated by the specific user with
        'user_id' to generate a k-fold (train/test) split. The rest of the
        data is used as training data only in any resulting split.
        :param user_id: The user_id, which is used for creating the k-fold split
        :return:
        """
        if not isinstance(user_ids, list):
            user_ids = [user_ids]
        # obtain the subset of data generated by the specific user
        mp_ids = np.arange(len(self.data_tensor))
        mp_sub = mp_ids[np.where(np.isin(self.uids, user_ids))[0]]

        # if area labels already set get subset for stratified split
        labels_sub = None
        if self.area_labels is not None:
            labels_sub = self.area_labels[np.where(np.isin(self.uids, user_ids))[0]]
            # one hot to class labels
            labels_sub = np.argmax(labels_sub, axis=1)

        # obtain the rest of the data not generate by specific user
        # will be added as training data to any split
        mp_rest = None
        diff = set(mp_ids.tolist()) - set(mp_sub.tolist())
        if len(diff) > 0:
            mp_rest = np.array(list(diff), dtype=mp_sub.dtype)

        # calculate the splits
        num_splits = int(1 / self.split_ratio['test'])
        if labels_sub is None:
            kf = KFold(n_splits=num_splits, shuffle=True,
                       random_state=self.random_state)
            folds = list(kf.split(mp_sub))
        else:
            kf = StratifiedKFold(n_splits=num_splits, shuffle=True,
                                 random_state=self.random_state)
            folds = list(kf.split(mp_sub, labels_sub))

        splits = []

        # setup the split indices tuple (also add training data of other users)
        for fold in folds:
            train_mp_idx = np.array([mp_sub[idx] for idx in fold[0]])
            test_mp_idx = np.array([mp_sub[idx] for idx in fold[1]])

            # append data of other devices to training data
            if mp_rest is not None:
                train_mp_idx = np.concatenate((train_mp_idx, mp_rest), axis=0)

            splits.append((train_mp_idx, test_mp_idx))

        self.splits_indices = splits
        self.num_splits = kf.get_n_splits(mp_sub)

    def _generate_split_indices(self):
        """
        Generates k-fold splitting indices for current data. If area labels
        are already set, use those to obtain a stratified split.
        :return:
        """
        data = self.data_tensor
        labels = self.area_labels

        min_percentage = min(self.split_ratio['train'],
                             self.split_ratio['test'])

        num_splits = int(1 / min_percentage)

        if labels is not None:
            kf = StratifiedKFold(n_splits=num_splits, shuffle=True,
                                 random_state=self.random_state)
            self.splits_indices = list(
                kf.split(data, np.argmax(labels, axis=1)))
        else:
            kf = KFold(n_splits=num_splits, shuffle=True,
                       random_state=self.random_state)
            self.splits_indices = list(kf.split(data))

        # reverse (train, test) of folds if test percentage > train percentage
        if self.split_ratio['test'] > self.split_ratio['train']:
            new_indices = []
            for (train, test) in self.splits_indices:
                new_indices.append((test, train))
            self.splits_indices = new_indices

        self.num_splits = kf.get_n_splits(data)

    def get_train_val_test(self, data=None, labels=None, split_idx=None, area_labels=True, noisy_labels=False, return_uids=False):
        if data is None:
            data = self.data_tensor
        if labels is None:
            if area_labels:
                if noisy_labels:
                    labels = self.noisy_area_labels
                else:
                    labels = self.area_labels
            else:
                if noisy_labels:
                    labels = self.noisy_labels
                else:
                    labels = self.labels

        if split_idx is None:
            split_idx = self.current_split_idx

        if labels is None:
            log.error("labels are none, probably tried to access area_labels, "
                      "but they were not computed/set, set labels as ground true position labels")
            labels = self.labels

        uids = self.uids

        split_indices = self.splits_indices

        # get data and labels according to generator mode and k-fold split idx
        train_val_idx, test_idx = split_indices[split_idx]
        x_train_val, x_test = data[train_val_idx], data[test_idx]
        y_train_val, y_test = labels[train_val_idx], labels[test_idx]
        if return_uids:
            train_val_uids, uid_test = uids[train_val_idx], uids[test_idx]

        # obtain separate validation data
        x_train, x_val, y_train, y_val = train_test_split(
            x_train_val, y_train_val, test_size=self.split_ratio['val'],
            random_state=self.random_state)

        if return_uids:
            # obtain separate validation data
            uid_train, uid_val, _, _ = train_test_split(
                train_val_uids, y_train_val, test_size=self.split_ratio['val'],
                random_state=self.random_state)

            return (x_train, x_val, x_test), (y_train, y_val, y_test), (uid_train, uid_val, uid_test)
        else:
            return x_train, x_val, x_test, y_train, y_val, y_test

    def get_train_data(self, data=None, labels=None, split_idx=None, area_labels=True, noisy_labels=False, return_uids=False):
        if return_uids:
            x, y, uids = self.get_train_val_test(data, labels, split_idx, area_labels, noisy_labels, return_uids)
            return x[0], y[0], uids[0]
        else:
            x_train, _, _, y_train, _, _ = self.get_train_val_test(data, labels, split_idx, area_labels, noisy_labels)
            return x_train, y_train

    def get_val_data(self, data=None, labels=None, split_idx=None, area_labels=True, noisy_labels=False, return_uids=False):
        if return_uids:
            x, y, uids = self.get_train_val_test(data, labels, split_idx, area_labels, noisy_labels, return_uids)
            return x[1], y[1], uids[1]
        else:
            _, x_val, _, _, y_val, _ = self.get_train_val_test(data, labels, split_idx, area_labels, noisy_labels)
            return x_val, y_val

    def get_test_data(self, data=None, labels=None, split_idx=None, area_labels=True, noisy_labels=False, return_uids=False):
        if return_uids:
            x, y, uids = self.get_train_val_test(data, labels, split_idx, area_labels, noisy_labels, return_uids)
            return x[2], y[2], uids[2]
        else:
            _, _, x_test, _, _, y_test = self.get_train_val_test(data, labels, split_idx, area_labels, noisy_labels)
            return x_test, y_test

    def get_train_val_test_num(self, data=None, labels=None, split_idx=None, area_labels=True, return_uids=False):
        x_train, x_val, x_test, _, _, _ = self.get_train_val_test(data, labels, split_idx, area_labels)

        return len(x_train), len(x_val), len(x_test)

    def get_data_dims(self, model_type="classification"):
        if model_type == "CNN":
            edge_len = int(np.ceil(np.sqrt(self.data_tensor.shape[1])))
            data_dims = (edge_len, edge_len, 1)
            try:
                label_dims = self.area_labels.shape[1]
            except AttributeError:
                label_dims = self.labels.shape[1]
        elif model_type == "CNN-PSSD":
            edge_len = self.data_tensor.shape[1]
            data_dims = (edge_len, edge_len, 1)
            label_dims = self.area_labels.shape[1]
        else:
            data_dims = self.data_tensor.shape[1]
            if model_type == "regression":
                label_dims = self.labels.shape[1]
            else:
                label_dims = self.area_labels.shape[1]

        return data_dims, label_dims

    def filter_temporary_access_points(self, temp_threshold):
        # problem if data deleted during cluster assignment?

        delete_aps = []

        data = self.data_tensor
        time = self.timestamps

        for ap_id in range(data.shape[1]):
            sub_ap_idx = np.where(data[:, ap_id] != 0)[0]

            if len(sub_ap_idx) == 0:
                continue

            ap_time = time[sub_ap_idx]

            ap_time_min = np.min(ap_time)
            ap_time_max = np.max(ap_time)

            ap_time_diff = ap_time_max - ap_time_min

            if ap_time_diff < temp_threshold:
                delete_aps.append(ap_id)
                print("AP: {}, diff: {}".format(ap_id, ap_time_diff))

        delete_aps = np.array(list(set(delete_aps)))
        keep_ids = np.where(~np.isin(np.arange(self.data_tensor.shape[1]), delete_aps))[0]

        self.data_tensor = self.data_tensor[:, keep_ids]

    def reset_split_indices_into_single_split_no_test_data(self):

        perm = np.random.permutation(np.arange(len(self.data_tensor)))
        self.splits_indices = [(perm, np.array([0]))]
        self.num_splits = 1

    def generate_random_splits_from_clusters(self, cluster_mappings, num_folds=5):
        # set random state for reproducability
        np.random.seed(self.random_state)

        # cluster indices excluding noise
        cluster_idx = list(range(np.max(cluster_mappings)))

        # determine random sequence of indices
        sampled_clusters = np.random.choice(cluster_idx, len(cluster_idx), replace=False)

        # store indices of members that are filtered as noise
        noise_idx = np.where(cluster_mappings == -1)[0]

        # set bounds that have to be matched during fold generation
        num_noise_per_split = int(len(noise_idx) / num_folds)
        num_test_per_split = (1.0/num_folds) * len(cluster_mappings)

        folds = []

        s_idx = 0
        n_idx = 0
        for fold in range(num_folds):
            test_idx = []

            #
            # fill test data from non-noisy clusters
            #
            while len(test_idx) < (num_test_per_split - num_noise_per_split):

                if s_idx == len(sampled_clusters):
                    # no more clusters available
                    break

                new_idx = sampled_clusters[s_idx]
                new_members = np.where(cluster_mappings == new_idx)[0]

                # enough data selected from base clusters, rest filled with noise
                if (len(test_idx) + len(new_members)) > (num_test_per_split - num_noise_per_split):
                    break

                s_idx += 1
                if len(test_idx) == 0:
                    test_idx = new_members
                else:
                    test_idx = np.concatenate([test_idx, new_members], axis=0)

            #
            # fill missing values with noise
            #

            # make sure not to exceed bounds of list

            upper_idx = n_idx + num_noise_per_split
            if upper_idx > len(noise_idx):
                upper_idx = len(noise_idx) - 1

            #upper_idx = max(n_idx + num_noise_per_split, len(noise_idx)-1)

            # add noise to test idx
            test_idx = np.concatenate([test_idx, noise_idx[n_idx: upper_idx]]).astype(int)
            n_idx += num_noise_per_split

            # set train idx non test idx
            train_idx = np.where(~np.isin(np.arange(len(cluster_mappings)), test_idx))[0]

            # shuffle indices
            np.random.shuffle(train_idx)
            np.random.shuffle(test_idx)

            folds.append((train_idx, test_idx))

        self.splits_indices = folds
        self.num_splits = len(folds)

    def generate_regression_split_indices_from_clusters(self, cluster_mappings, num_folds=5):

        # get random subset of mappings until 20% of data
        kf = KFold(n_splits=num_folds, shuffle=False,
                   random_state=self.random_state)
        cluster_idx = list(range(np.max(cluster_mappings)))
        c_folds = list(kf.split(cluster_idx))

        folds = []

        for (train, test) in c_folds:
            train = np.append(train, -1)
            train_idx = np.where(np.isin(cluster_mappings, train))[0]
            test_idx = np.where(np.isin(cluster_mappings, test))[0]
            folds.append((train_idx, test_idx))

        self.splits_indices = folds
        self.num_splits = len(folds)

    def augmentate_data(self, mode='train', missing_val=-110, num_augs=3):
        if mode == 'train':
            x_train, y_train = self.get_train_data()
        elif mode == 'val':
            x_train, y_train = self.get_train_data()
        elif mode == 'test':
            x_train, y_train = self.get_train_data()

        x_aug = []
        y_aug = []
        for area_id in range(y_train.shape[1]):
            area_mask = np.where(np.argmax(y_train, axis=1) == area_id)[0]
            x_area, y_area = x_train[area_mask, :], y_train[area_mask, :]

            area_ap_mean = np.nanmean(x_area, axis=0)

            aug_tensors = np.concatenate(tuple(x_area for _ in range(num_augs)), axis=0)
            for r_idx, row in enumerate(x_area):
                for c_idx, val in enumerate(row):
                    val = missing_val if np.isnan(val) else val
                    if np.isnan(area_ap_mean[c_idx]):
                        area_ap_mean[c_idx] = missing_val
                    diff = area_ap_mean[c_idx] - val
                    if diff != 0:
                        samples = np.random.random_sample(num_augs) * diff

                        # insert samples into aug_tensors
                        for aug_idx in range(num_augs):
                            aug_tensors[r_idx + aug_idx * len(x_area), c_idx] += samples[aug_idx]

            aug_area = np.concatenate((x_area, aug_tensors), axis=0)
            aug_labels = np.concatenate(tuple(y_area for _ in range(num_augs + 1)), axis=0)

            x_aug.append(aug_area)
            y_aug.append(aug_labels)

        return np.concatenate(x_aug, axis=0), np.concatenate(y_aug, axis=0)

    def calculate_pearson_correlation_between_AP_and_locations(self):
        num_aps = self.data_tensor.shape[1]
        p_corr = np.zeros(num_aps)
        for ap in range(num_aps):

            p_corr[ap] = pearsonr(self.data_tensor[:, ap], np.argmax(self.area_labels, axis=1))[0]

        return p_corr

    def remove_APs_with_low_correlation_to_areas(self, params):

        if "pearsoncorr" in params:
            threshold = params["pearsoncorr"]

            p_corr = self.calculate_pearson_correlation_between_AP_and_locations()

            # only absolute values
            p_corr = np.absolute(p_corr)

            subset = np.where(p_corr > threshold)[0]

            self.data_tensor = self.data_tensor[:, subset]

            return subset

        return None

    def transform_batch_to_pairwise_diff_image(self, batch):

        images = []
        num_acc = batch.shape[1]

        for row in batch:
            b_img = row[:, np.newaxis] - row[np.newaxis, :]
            images.append(b_img)

        batch = np.array(images)
        batch = batch.reshape((len(batch), num_acc, num_acc, 1))

        return batch

    def transform_batch_to_image(self, batch, pearsoncorr=False):

        if pearsoncorr:
            p_corr = self.calculate_pearson_correlation_between_AP_and_locations()

            batch = batch * p_corr

        # get picture edge length
        num_acc = batch.shape[1]

        dim = int(np.ceil(np.sqrt(num_acc)))

        # pad rss values with zeros
        diff = dim ** 2 - num_acc
        pad_tensor = np.zeros((len(batch), diff))

        batch = np.concatenate((batch, pad_tensor), axis=1)

        # single channel in last dimension
        batch = batch.reshape((len(batch), dim, dim, 1))

        return batch

    def add_class_label_noise(self, labels, noise_percentage=None):
        if noise_percentage is not None:
            # number of labels that will be corrupted
            num_nl = int(noise_percentage * len(labels))

            # random sample of labels
            random_idx = np.random.randint(
                0, len(labels) - 1, num_nl)

            # compute random shifts
            shifts = np.random.random_integers(1, labels.shape[1] - 1, num_nl)

            # compute position inside one hot vector and add shift
            # (modulo the dimension)
            a_max = np.argmax(labels[random_idx, :], axis=1)
            noisy_labels = np.fmod(a_max + shifts, labels.shape[1] - 1)

            # apply shift to sampled
            labels[random_idx, :] = 0
            labels[random_idx, noisy_labels] = 1

        return labels

    def in_mem_data_generator(self, split_idx=None, mode='train', area_labels=True, augmentation=None, noise_percentage=None, noisy_labels=False, model_type="classification", batch_size=32):
        if split_idx is None:
            split_idx = self.current_split_idx

        if mode == 'train':
            data, labels = self.get_train_data(split_idx=split_idx, area_labels=area_labels, noisy_labels=noisy_labels)
        if mode == 'val':
            data, labels = self.get_val_data(split_idx=split_idx, area_labels=area_labels, noisy_labels=noisy_labels)
        if mode == 'test':
            data, labels = self.get_test_data(split_idx=split_idx, area_labels=area_labels, noisy_labels=noisy_labels)

        if augmentation is not None and augmentation > 0:
            data, labels = self.augmentate_data(num_augs=augmentation, missing_val=0)

        if model_type == "CNN":
            data = self.transform_batch_to_image(data, pearsoncorr=False)
        elif model_type == "CNN-PSSD":
            data = self.transform_batch_to_pairwise_diff_image(data)

        labels = self.add_class_label_noise(labels, noise_percentage)

        num_batches = math.ceil(len(data) / batch_size)
        while True:

            for run_id in range(num_batches):
                b_data = data[run_id * batch_size:(run_id + 1) * batch_size, :]
                b_labels = labels[run_id * batch_size:(run_id + 1) * batch_size, :]

                yield (b_data, b_labels)

    def normalize_rank_transformation(self):
        sorted_data = np.sort(self.data_tensor, axis=1)
        rank_data = np.zeros(self.data_tensor.shape)
        for r_idx, row in enumerate(sorted_data):
            last_val = 0
            rank = 0
            for v_idx, val in enumerate(row):
                if val != last_val:
                    rank += 1
                rank_data[r_idx, v_idx] = rank
                last_val = val

        # normalize
        max_rank = np.max(rank_data, axis=1)
        for idx, (row, max_r) in enumerate(zip(rank_data, max_rank)):
            rank_data[idx, :] = np.divide(row, max_r)

    def transform_into_tensor(self, df=None, missing_val=-110.0):
        """
        Transforms the pandas dataframe into a tensor (matrix) where each column
        represents a specific access point. If the dataset has a specific column
        'split', with values (train or test) indicating the split for training,
        this is used to generate a single train/test split. Also calculates class
        variable self.uids which holds for each data row the associated user id.
        :return:
        """
        if df is None:
            df = self.filtered_df
        if 'split' in df:
            # generate split indices from df entries
            train_idx = set()
            test_idx = set()

        pids = df.drop_duplicates(subset=["id"])["id"].values
        num_mac = len(self.mac_addresses_df.values)

        tensor = np.full((len(pids), num_mac), missing_val, dtype=float)
        uids = np.zeros(len(pids))
        timestamps = np.zeros(len(pids))
        labels = np.zeros((len(pids), 2))

        for _, row in df.iterrows():
            mac_idx = np.where(
                self.mac_addresses_df["macAddress"].values == row[
                    "macAddress"])[0]

            pid_idx = np.where(pids == row["id"])[0]
            tensor[pid_idx, mac_idx] = row["rssValue"]
            labels[pid_idx, 0] = row["cellX"]
            labels[pid_idx, 1] = row["cellY"]
            uids[pid_idx] = row["createdBy"]
            timestamps[pid_idx] = row["timeStamp"]

            # add row to train or test split if specified
            if 'split' in df:
                if row['split'] == 'train':
                    train_idx.add(pid_idx[0])
                elif row['split'] == 'test':
                    test_idx.add(pid_idx[0])

        self.col_df = pd.DataFrame(data=tensor)

        # setup single fold split indices
        if 'split' in df:
            self.splits_indices = [(np.array(list(train_idx)),
                                    np.array(list(test_idx)))]
            self.num_splits = 1

        self.labels = labels
        self.data_tensor = tensor
        self.uids = uids
        self.timestamps = timestamps

        return tensor, labels

    def standardize_data(self, apply_z_score=False, column_wise=True):
        """
        Standardizes the dataset (removes columns with std=0) by applying
        z-score normalization.
        :return:
        """
        if self.data_tensor is None:
            return

        if not apply_z_score:
            min_AP_val = np.min(self.data_tensor)
            max_AP_val = np.max(self.data_tensor)
            self.data_tensor = (self.data_tensor - min_AP_val) / (max_AP_val - min_AP_val)
            return

        col_std = self.col_df.apply(np.std)
        non_zero_std = np.where(col_std != 0)[0]

        self.col_df = self.col_df.iloc[:, non_zero_std]
        self.mac_addresses_df = self.mac_addresses_df.iloc[non_zero_std]

        self.col_df = self.col_df.apply(zscore)

        self.data_tensor = self.col_df.values

    def apply_filters(self, filters):
        """
        Applies a set of filters on the read dataframe
        :param filters: A list of Filter
        :return:
        """
        self.filtered_df = self.measurements_df
        for filter in filters:
            self.filtered_df = filter.apply_on_df(self.filtered_df)

    def setup_filters(self, pre_params):
        # set up all filters that are sequentially applied to generate
        # the desired subset of data
        data_filters = []

        if 'filters' in pre_params:
            filters = pre_params['filters']

            for filter in filters:
                f_type = filter["type"]

                if f_type == "device_filter":
                    u_id = filter["user_id"]
                    ratio = filter["ratio"]
                    mode = filter["mode"]

                    # setup device filter
                    device_filter = DeviceFractionFilter(
                        "createdBy", u_id, ratio, "filter", mode)
                    data_filters.append(device_filter)

                if f_type == "loc_filter":
                    # setup two location filters
                    x = filter["x"]
                    y = filter["y"]
                    ratio = filter["ratio"]
                    mode = filter["mode"]

                    location_filter = LocationFractionFilter(x, y, ratio, mode)
                    data_filters.append(location_filter)

                if f_type == "loc_filters":
                    loc_filters = MultipleLocationFractionFilter(filter)
                    data_filters.append(loc_filters)

                if f_type == "device_filters":
                    dev_filters = MultipleDeviceFractionFilter(filter)
                    data_filters.append(dev_filters)

                if f_type == "col_filter":
                    col = filter["col"]
                    values = filter["values"]
                    col_filter = IsInFilter(col, values)
                    data_filters.append(col_filter)

                if f_type == "range_filter":
                    col = filter["col"]
                    val = filter["range"]
                    mode = filter["mode"]
                    range_filter = RangeFilter(col, val, mode)
                    data_filters.append(range_filter)

        return data_filters